/*-------------------------------------------------------------------------
 *
 * pipelinefuncs.h
 *
 *	  Interface for PipelineDB functions
 *
 * Copyright (c) 2013-2015, PipelineDB
 *
 * IDENTIFICATION
 *	  src/backend/utils/pipelinefuncs.h
 *
 *-------------------------------------------------------------------------
 */
#ifndef PIPELINEFUNCS_H
#define PIPELINEFUNCS_H


#define DISPLAY_OVERLAY_VIEW -2

/* continuous query process stats */
extern Datum cq_proc_stat_get(PG_FUNCTION_ARGS);

/* continuous query stats */
extern Datum cq_stat_get(PG_FUNCTION_ARGS);

/* stream stats */
extern Datum stream_stat_get(PG_FUNCTION_ARGS);

/* pipeline views */
extern Datum pipeline_views(PG_FUNCTION_ARGS);

/* pipeline transforms */
extern Datum pipeline_transforms(PG_FUNCTION_ARGS);

/* pipeline streams */
extern Datum pipeline_streams(PG_FUNCTION_ARGS);

/* global pipeline stats */
extern Datum pipeline_stat_get(PG_FUNCTION_ARGS);

/* matrel overlay view definition */
extern Datum pipeline_get_overlay_viewdef(PG_FUNCTION_ARGS);

/* PipelineDB version string */
extern Datum pipeline_version(PG_FUNCTION_ARGS);

extern Datum pipeline_get_worker_querydef(PG_FUNCTION_ARGS);

extern Datum pipeline_get_combiner_querydef(PG_FUNCTION_ARGS);

extern Datum pipeline_combine_table(PG_FUNCTION_ARGS);

extern Datum json_object_int_sum_transfn(PG_FUNCTION_ARGS);

extern Datum json_object_int_sum_transout(PG_FUNCTION_ARGS);

extern Datum pipeline_flush(PG_FUNCTION_ARGS);

extern Datum set_ttl(PG_FUNCTION_ARGS);

extern Datum ttl_expire(PG_FUNCTION_ARGS);

#endif
